#ifndef TARTANALOOPNEBULAHPC_HH
#define TARTANALOOPNEBULAHPC_HH

#include "TArtAnaLoop.hh"

#include "TArtSAMURAIParameters.hh"
#include "TArtCalibNEBULA.hh"
#include "TArtNEBULAPla.hh"
#include "TArtNEBULAPlaPara.hh"
#include "TArtCalibNEBULAHPC.hh"
#include "TArtNEBULAHPC.hh"
#include "TArtNEBULAHPCPara.hh"

class TArtAnaLoopNEBULAHPC : public TArtAnaLoop
{
public:
  TArtAnaLoopNEBULAHPC();
  ~TArtAnaLoopNEBULAHPC();

protected:
  void Construct();
  void Calculate();
  void Destruct();

  void AddNEBULA();
  void AddNEBULAHPC();

  TArtSAMURAIParameters *samuraiparameters;

  TArtCalibNEBULA *calibnebula;
  TArtCalibNEBULAHPC *calibnebulahpc;

public:
  const char* ClassName() const;

  ClassDef(TArtAnaLoopNEBULAHPC,1);
};

#endif
