// PPAC calibration class
// 

#ifndef _TARTCALIBPPAC_H_
#define _TARTCALIBPPAC_H_

#include <TClonesArray.h>
#include <TString.h>

class TArtRawEventObject;
class TArtRawSegmentObject;
class TArtPPACPara;
class TArtBigRIPSParameters;
class TArtPPAC;
class TArtStoreManager;

class TArtCalibPPAC  {

 public:

  TArtCalibPPAC();
  virtual ~TArtCalibPPAC();

  void LoadData();
  void LoadData(TArtRawSegmentObject *seg);
  void ClearData();
  void ReconstructData();
  void ReconstructData(TArtPPAC *ppac, TArtPPACPara *para);

  bool IsReconstructed(){ return fReconstructed; }

  // function to access data container
  TClonesArray    * GetPPACArray(){return fPPACArray;}
  Int_t             GetNumPPAC();
  TArtPPAC     * GetPPAC(int i);
  TArtPPACPara * GetPPACPara(int i);
  // looking for ic whose id is i. return NULL in the case of fail to find.
  TArtPPAC     * FindPPAC(int i);
  // looking for ic whose id is i. return NULL in the case of fail to find.
  TArtPPAC     * FindPPAC(TString *n);
  TArtPPAC     * FindPPAC(char *n);

 private:

  bool fDataLoaded;
  bool fReconstructed;

  TClonesArray       * fPPACArray;
  // temporal buffer for pointer for ppac parameter
  std::vector <TArtPPACPara*> fPPACParaArray;

  TArtBigRIPSParameters * setup;
  TArtStoreManager * sman;

  ClassDef(TArtCalibPPAC,1);

};

#endif
