// ribf beam reconstruction class
// 

#ifndef _TARTRECOBeam_H_
#define _TARTRECOBeam_H_

#include <TNamed.h>
#include <TClonesArray.h>

class TArtBigRIPSParameters;
class TArtRIPS;
class TArtTOF;
class TArtIC;
class TArtBeam;
class TArtStoreManager;

class TArtRecoBeam  {

 public:

  TArtRecoBeam();
  TArtRecoBeam(TArtBigRIPSParameters * s);
  virtual ~TArtRecoBeam();

  void ClearData();
  void ReconstructData();

  bool IsReconstructed(){ return fReconstructed; }
  TArtBeam * DefineNewBeam(TArtRIPS *rips, TArtTOF *tof, char * icname);
  TArtBeam * DefineNewBeam(TArtRIPS *urips, TArtRIPS *drips, TArtTOF *tof, char * icname);

  // function to access data container
  TClonesArray    * GetBeamArray(){return fBeamArray;}
  Int_t             GetNumBeam();
  // get i-th object in array
  TArtBeam  * GetBeam(int i);
  // looking for fpl object whose forward fpl-number is f_fpl and backward fpl-number is b_fpl. return NULL in the case of fail to find.

 private:

  bool fReconstructed;

  TClonesArray       * fBeamArray;
  TArtStoreManager * sman;

  Double_t clight, mnucleon;

  ClassDef(TArtRecoBeam,1);

};

#endif
