// DALI calibration class
// 

#ifndef _TARTCALIBDALI_H_
#define _TARTCALIBDALI_H_

#include <TNamed.h>

class TArtRawSegmentObject;
class TArtDALINaIPara;
class TArtDALIParameters;
class TArtDALINaI;
class TArtStoreManager;

class TArtCalibDALI  {

 public:

  TArtCalibDALI();
  virtual ~TArtCalibDALI();

  void LoadRawData();
  void LoadRawData(TArtRawSegmentObject *);
  void ClearData();
  void ReconstructData();

  bool IsReconstructed(){ return fReconstructed; }

  // function for doppler correct
  void DopplerCorrect();
  void DopplerCorrect(Double_t beta);

  // function to access data container
  TClonesArray    * GetNaIArray(){return fNaIArray;}
  Int_t             GetNumNaI();
  TArtDALINaI     * GetNaI(int i);
  TArtDALINaIPara * GetNaIPara(int i);
  // looking for nai whose id is i. return NULL in the case of fail to find.
  TArtDALINaI     * FindNaI(int i);

 private:

  bool fDataLoaded;
  bool fReconstructed;

  TClonesArray       * fNaIArray;
  // temporal buffer for pointer for nai parameter
  std::vector <TArtDALINaIPara*> fNaIParaArray;

  TArtDALIParameters * setup;
  TArtStoreManager * sman;

  ClassDef(TArtCalibDALI,1);

 };

#endif
