// SiStopper calibration class
// 

#ifndef _TARTCALIBSISTOPPER_H_
#define _TARTCALIBSISTOPPER_H_

#include <TNamed.h>

class TArtRawSegmentObject;
class TArtSiStopperPara;
class TArtEURICAParameters;
class TArtSiStopper;
class TArtStoreManager;

class TArtCalibSiStopper  {

 public:

  TArtCalibSiStopper();
  virtual ~TArtCalibSiStopper();

  void LoadData();
  void LoadData(TArtRawSegmentObject *);
  void ClearData();
  void ReconstructData();

  bool IsReconstructed(){ return fReconstructed; }

  // function to access data container
  TClonesArray    * GetSiStopperArray(){return fSiStopperArray;}
  Int_t             GetNumSiStopper();
  TArtSiStopper     * GetSiStopper(int i);
  TArtSiStopperPara * GetSiStopperPara(int i);
  // looking for si whose id is i. return NULL in the case of fail to find.
  TArtSiStopper     * FindSiStopper(int i);

 private:

  bool fDataLoaded;
  bool fReconstructed;

  TClonesArray       * fSiStopperArray;
  // temporal buffer for pointer for si parameter
  std::vector <TArtSiStopperPara*> fSiStopperParaArray;

  TArtEURICAParameters * setup;
  TArtStoreManager * sman;

  ClassDef(TArtCalibSiStopper,1);

 };

#endif
