#ifndef _TARTEURICAPARAMETERS_H_
#define _TARTEURICAPARAMETERS_H_

#include <TROOT.h>
#include <TList.h>
#include <map>

class TXMLNode;
class TArtSiStopperPara;
class TArtRIDFMap;

class TArtEURICAParameters : public TNamed
{
 public: 

  TArtEURICAParameters();
  ~TArtEURICAParameters();
  Bool_t LoadParameter(char *xmlfile);

  TList* GetListOfSiStopperPara() {return listOfSiStopperPara; }
  Int_t GetNumSiStopperPara() {return listOfSiStopperPara->GetEntries(); }
  TArtSiStopperPara * GetSiStopperPara(TArtRIDFMap *rmap);

 protected:

  std::map<TArtRIDFMap, TArtSiStopperPara *> pmap;
  std::map<TArtRIDFMap, TArtSiStopperPara *>::iterator itrEnd;
  std::map<TArtRIDFMap, TArtSiStopperPara *>::iterator itr;

  TList *listOfSiStopperPara;

  void ParseParaList(TXMLNode *node);
  TArtSiStopperPara * ParseSiStopperPara(TXMLNode *node);

  ClassDef(TArtEURICAParameters,1);

};

#endif
