#ifndef _TARTGECLUSTER_H_
#define _TARTGECLUSTER_H_

#include "TArtDataObject.h"

class TArtGeCluster: public TArtDataObject {

 public:
  TArtGeCluster(){}
  virtual ~TArtGeCluster(){}

  // function to set raw data
  virtual void  SetChannel(int val){channel = val;}
  virtual void  SetRawADC(int val){fADC = val;}
  virtual void  SetRawTDC(int val){fTDC = val;}

  // function to get raw data
  virtual int  GetChannel(){return channel;}
  virtual unsigned int GetRawADC(){return fADC;}
  virtual unsigned int GetRawTDC(){return fTDC;}

  // function to set calibrated data
  virtual void  SetEnergy(int val){fEnergy = val;}
  virtual void  SetTiming(int val){fTime = val;}

  // function to get calibrated data
  virtual Double_t GetEnergy(){return fEnergy;}
  virtual Double_t GetTiming(){return fTime;}

 private:
  int channel;  

  // raw value
  unsigned int fADC;  
  unsigned int fTDC;  

  // calibrated value
  Double_t fEnergy;
  Double_t fTime;

  ClassDef(TArtGeCluster,1);

};
#endif
