// NEBULA calibration class
// 

#ifndef _TARTCALIBNEBULA_H_
#define _TARTCALIBNEBULA_H_

#include <TNamed.h>
#include <vector>
#include <map>

class TClonesArray;
class TArtStoreManager;
class TArtSAMURAIParameters;

class TArtNEBULAPla;
typedef TClonesArray TArtNEBULAPlaArray;
class TArtNEBULAPlaPara;
typedef TClonesArray TArtNEBULAPlaParaArray;

class TString;

class TArtCalibNEBULA
{
public:
  TArtCalibNEBULA();
  virtual ~TArtCalibNEBULA();

  void LoadRawData();
  void ReconstructData();
  void ClearData();

  bool IsReconstructed(){return fReconstructed;}

  Int_t GetNumNEBULAPla() const;
  TArtNEBULAPla* GetNEBULAPla(int i) const;
  TArtNEBULAPla* FindNEBULAPla(int id) const;//find by id
  TArtNEBULAPlaArray* GetNEBULAPlaArray() const;
  Int_t GetNumNEBULAPlaPara() const;
  TArtNEBULAPlaPara* GetNEBULAPlaPara(int i) const;
  TArtNEBULAPlaPara* FindNEBULAPlaPara(int id) const;//find by id
  TArtNEBULAPlaParaArray* GetNEBULAPlaParaArray() const;

private:
  bool fReconstructed;

  TArtNEBULAPlaArray* fNEBULAPlaArray;
  TArtNEBULAPlaParaArray* fNEBULAPlaParaArray;

  const TArtSAMURAIParameters* fSAMURAIParameters;

  TArtStoreManager* fStoreManager;

  //for optimization
  std::map<int,int> fIDNPlaMap;
  std::map<int,int> fIDNPlaParaMap;

  ClassDef(TArtCalibNEBULA,1);
};

#endif
