#ifndef _TARTNEBULAHPC_H_
#define _TARTNEBULAHPC_H_

#include "TObject.h"
#include "TString.h"

#include <iostream>

class TArtNEBULAHPC : public TObject
{
public:
  TArtNEBULAHPC()
    : TObject(), fDataState(0),
      fID(-1), fName(""), fFPl(-1), fLayer(-1), fSubLayer(-1),
      fTRaw(-1), fTCal(-1)
  {
    for(int i=0; i<3; ++i) fDetPos[i] = 0;
  }
  virtual ~TArtNEBULAHPC(){;}

  virtual void SetDataState(Int_t val){fDataState = val;}

  virtual void SetID(Int_t val){fID = val;}
  virtual void SetDetectorName(const TString& val){fName = val;}
  virtual void SetFPl(Int_t val){fFPl = val;}
  virtual void SetLayer(Int_t val){fLayer = val;}
  virtual void SetSubLayer(Int_t val){fSubLayer = val;}
  virtual void SetDetPos(const Double_t* val){for(int i=0; i<3; ++i){fDetPos[i] = val[i];}}
  virtual void SetDetPos(Double_t val, Int_t i){fDetPos[i] = val;}

  virtual void SetTRaw(Int_t    val){fTRaw = val;}
  virtual void SetTCal(Double_t val){fTCal = val;}

  virtual Int_t GetDataState() const {return fDataState;}

  virtual Int_t GetID() const {return fID;}
  virtual const TString& GetDetectorName() const {return fName;}
  virtual Int_t GetFPl() const {return fFPl;}
  virtual Int_t GetLayer() const {return fLayer;}
  virtual Int_t GetSubLayer() const {return fSubLayer;}
  virtual const Double_t* GetDetPos() const {return fDetPos;}
  virtual Double_t GetDetPos(int i) const {return fDetPos[i];}

  virtual Int_t    GetTRaw() const {return fTRaw;}
  virtual Double_t GetTCal() const {return fTCal;}

private:
  // fDataState<0:invalid, fDataState==0:initial, fDataState>0:valid
  Int_t    fDataState;

  Int_t    fID;
  TString  fName;
  Int_t    fFPl;
  Int_t    fLayer;  
  Int_t    fSubLayer;  
  Double_t fDetPos[3];

  Int_t    fTRaw;
  Double_t fTCal;

  ClassDef(TArtNEBULAHPC,1);
};

#endif

